<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Regular Pumping Lemmas</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070726;14380700">
	<META NAME="CHANGED" CONTENT="20070803;15571300">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Regular Pumping Lemmas</H1>
<H2>Contents</H2>
<P><A HREF="#definition">Definition</A><BR><A HREF="#game">Explaining
the Game</A><BR><A HREF="#start">Starting the Game</A><BR><A HREF="#user">User
Goes First</A><BR><A HREF="#computer">Computer Goes First</A> 
</P>
<P>This game approach to the pumping lemma is based on the approach
in Peter Linz's <I>An Introduction to Formal Languages and Automata.</I></P>
<H2 STYLE="font-style: normal"><A NAME="definition"></A>Definition</H2>
<P>JFLAP defines a regular pumping lemma to be the following. Let <I>L</I>
be an infinite regular language. Then there exists some positive
integer <I>m</I> such that any <I>w</I> that is a member of<!--&#8712;--><!--element of-->
<I>L</I> with |<I>w</I>| ≥<!--greater than or equal--> <I>m</I> can
be decomposed as 
</P>
<P ALIGN=CENTER><I>w</I> = <I>xyz</I>, 
</P>
<P>with 
</P>
<P ALIGN=CENTER>|<I>xy</I>| ≤<!--less than or equal--> <I>m</I>, 
</P>
<P>and 
</P>
<P ALIGN=CENTER>|<I>y</I>| ≥<!--greater than or equal--> 1, 
</P>
<P>such that 
</P>
<P ALIGN=CENTER><I>w<SUB>i</SUB></I> = <I>xy<SUP>i</SUP>z</I>, 
</P>
<P>is also in <I>L</I> for all <I>i</I> = 0, 1, 2, .... 
</P>
<P>In other words, any sufficiently long string in <I>L</I> can be
broken down into three parts such that any number of repetitions of
the middle part (pumping the middle part) will still yield in a
string in <I>L</I>. 
</P>
<H2><A NAME="game"></A>Explaining the Game</H2>
<P>JFLAP treats the regular pumping lemma as a two-player game. In
the game below, Player A is trying to find a <I>xyz</I> decomposition
that is always in the language no matter what the <I>i</I> value is. 
Player B is trying to make it as hard as possible for player A to do
so. If player B can pick a strategy such that he or she will always
win regardless of player A's choices, meaning that no adequate
decomposition exists, it is equivalent to proof that the language is
not regular. The game is played like this: 
</P>
<OL>
	<LI><P STYLE="margin-bottom: 0in">Player A picks an integer for <I>m</I>.
		</P>
	<LI><P STYLE="margin-bottom: 0in">Player B picks a string <I>w</I>
	such that <I>w</I> is a member of<!--&#8712;--><!--element of--> <I>L</I>
	and |<I>w</I>| ≥<!--greater than or equal--> <I>m</I>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">Player A picks the partition of <I>w</I>
	into <I>xyz</I> such that |<I>xy</I>| ≥ <I>m</I> and |<I>y</I>| ≥
	1. 
	</P>
	<LI><P>Player B picks an integer <I>i</I> such that <I>xy<SUP>i</SUP>z</I>
	is not a member of<!--&#8713--><!--not element of--> <I>L</I>. If
	player B can do so player B wins, otherwise, player A wins. 
	</P>
</OL>
<P>There are two possible modes for the game, when the user goes
first and when the computer goes first. In the first mode, the user
is player A and the computer is player B, and thus the user should be
trying to find an acceptable decomposition to pump. In the second
mode, the user is player B and the computer is player A, and thus the
user should be trying to prevent the computer from generating a valid
decomposition.</P>
<H2><A NAME="start"></A>Starting the Game</H2>
<P>To start a regular pumping lemma game, select <B>Regular Pumping
Lemma</B> from the main menu: 
</P>
<P ALIGN=CENTER><IMG SRC="images/menu" NAME="Graphic1" ALIGN=MIDDLE WIDTH=233 HEIGHT=321 BORDER=0></P>
<P>You will then see a new window that prompts you both for which
mode you wish to utilize and which language you wish to work on. The
default mode is for the user to go first. A list of languages is also
shown, some of which are regular and some of which are not regular. 
To proceed to a language, click on the appropriate “Select”
button, and a new screen will come up based on the language chosen
and the mode selected when the button was pushed.</P>
<P ALIGN=CENTER><IMG SRC="images/chooser" NAME="Graphic2" ALIGN=MIDDLE WIDTH=700 HEIGHT=700 BORDER=0></P>
<H2><A NAME="user"></A>User Goes First</H2>
<P>Let's do an example for when the user goes first. Since the “You
go first” option is already selected, we do not need to do anything
in the top panel. Now we need to choose a language. Let's try the
first language on the screen, L = {a<SUP>n</SUP>b<SUP>n</SUP> : n ≥
0}. Go ahead and press the “Select” button to the right of the
language. The following screen should come up.</P>
<P ALIGN=CENTER><IMG SRC="images/humanintro" NAME="Graphic3" ALIGN=MIDDLE WIDTH=700 HEIGHT=700 BORDER=0></P>
<P>You may be curious about all the various items on the screen. We
will touch all of them in time, but for now, let's play the game. We
see that our objective in this mode is to find a valid partition, and
that the first step that we need to preform is to choose a value for
<I>m</I>. Go ahead and enter a fairly large value for <I>m</I>, such
as 20, in the box where you are prompted. If the value is too large,
the following message should appear in the panel where you entered <I>m</I>.</P>
<P ALIGN=CENTER><IMG SRC="images/merror" NAME="Graphic4" ALIGN=MIDDLE BORDER=0></P>
<P>JFLAP will only accept values for <I>m</I> in a finite range, both
so <I>m</I> is large enough and so unnecessarily large values are
avoided. Now, go ahead and enter “4”, which is a value of m in
accepted range. The error message should disappear, and the following
two panels should now be visible on the screen under the <I>m</I>
panel.</P>
<P ALIGN=CENTER><IMG SRC="images/2&amp;3visible" NAME="Graphic4" ALIGN=MIDDLE WIDTH=642 HEIGHT=232 BORDER=0></P>
<P>The computer has chosen a value for <I>w</I>, and now the game
prompts you to decompose the string. You can adjust the <I>x</I>, <I>y</I>,
and <I>z </I>substrings by using the sliders to set the boundaries
between them. The first slider will set the boundary between <I>x</I>
and <I>y</I>, and the second will set the boundary between <I>y </I>and
<I>z</I>. If the decomposition is acceptable, the “Set xyz”
button will become visible and the message at the bottom of the panel
will inform you that you can set the button. If it is unacceptable,
the message at the bottom will inform you what the problem is with
the current decomposition.</P>
<P STYLE="font-style: normal">Let's have <I>x</I> and <I>y</I> both
equal “aa”. Go ahead and slide the top slider over two spaces.
You should notice that the bottom slider also moves too. Then, slide
the bottom slider over two more spaces, and then click the visible
“Set xyz” button. You should notice that the decomposition for
each substring appears in the appropriate boxes as you move the
sliders, in addition to the lengths of the substrings (note however
that all fields may not be filled in if the decomposition is
invalid). When finished, the message in the decomposition panel will
disappear, the last two panels will become visible, and the whole
screen will look like this.</P>
<P ALIGN=CENTER><IMG SRC="images/4&amp;5visible" NAME="Graphic5" ALIGN=MIDDLE WIDTH=700 HEIGHT=700 BORDER=0></P>
<P>There are a number of things that you should notice. First, in the
panel below the decomposition panel, we see that the computer has
chosen a value for <I>i</I>, which is 0. It also shows the pumped
string, which is “aabbbb”. The panel below informs you that you
have lost, as the pumped string is not in the language. This panel
also allows you to see an animation of how the pumped string is
assembled. Press the “Step” button to see each step in the
animation, and the button will lose its visibility when all steps
have been completed. “Restart”, if visible, will restart the
animation at the beginning. When the animation is finished, the
bottom panel should look like this.</P>
<P ALIGN=CENTER><IMG SRC="images/finishedanimation" NAME="Graphic5" ALIGN=MIDDLE WIDTH=643 HEIGHT=175 BORDER=0></P>
<P>You should also notice that there is new information in the text
box in the top panel. What is listed here is all the attempts that
you have made to win this game. Scroll down a little in this text box
and you should see your decomposition, <I>i</I> value, and result
(either <I>Failed </I>or <I>Won</I>) for each attempt.</P>
<P ALIGN=CENTER><IMG SRC="images/firstattempt" NAME="Graphic5" ALIGN=MIDDLE BORDER=0></P>
<P>Since we have made only one attempt so far, only one attempt is
listed. If we try a few more times, more attempts will be added to
the list. The more recent the attempt, the closer it will be to the
top of the list. There are a variety of ways to try again. If we are
happy with our <I>m</I> and <I>w</I> values, we can simply choose a
new decomposition in the decomposition panel and press the “Set
xyz” button. If, however, we wish to change the <I>m</I> value, we
can either enter a new value in the <I>m</I> panel directly or press
the “Clear All” button, which is in the top panel, and then enter
a new <I>m</I> value. If you press the “Clear All” button, notice
that the list of attempts remains visible. After entering a new <I>m</I>
value and after the computer picks a new <I>w</I> value, you would
then choose a new decomposition. The visibility of all panels will be
updated to reflect the current stage of the game.</P>
<P>After a few attempts, you may notice that you never win, no matter
what <I>m </I>value you choose or which decomposition you pick.
However, if you don't spot the strategy that the computer is
employing, you may wonder whether you are simply choosing your values
poorly or whether it is indeed impossible to win. Once you have made
enough attempts, feel free to press the “Explain” button in the
top panel. You will now see, in the text box where the attempts are
listed (you can still see them if you scroll down further), whether a
valid partition exists. Below this information is an informal,
intuitive proof about why there is or is not a valid partition. For
this example, there is indeed no valid partition. To get rid of the
proof and information about the possibility of a valid partition,
simply click on the “Clear All” button.</P>
<P>The example you just generated is available in <A HREF="regUserFirst.jff">regUserFirst.jff</A>.</P>
<H2><A NAME="computer"></A>Computer Goes First</H2>
<P>When finished, dismiss the tab, and you will return to the
language selection screen. In the top panel, click on “Computer
goes first.” Then, choose the first language, L = {a<SUP>n</SUP>b<SUP>n</SUP>.
: n ≥ 0}, again. The following screen should come up.</P>
<P ALIGN=CENTER><IMG SRC="images/compintro" NAME="Graphic3" ALIGN=MIDDLE WIDTH=700 HEIGHT=700 BORDER=0></P>
<P STYLE="margin-bottom: 0in">You will notice a few things different
from when you went first. First, the objective has changed. Your
purpose is to prevent the computer from finding a valid partition.
Second, the messages for each step in the game have changed,
reflecting the different tasks you must perform as player B. The
computer has chosen a value for <I>m</I> within the permissible
range, in this case 9. You are prompted for a value for <I>w</I>. Go
ahead and enter the string “aaaaabbbbb”, which is the smallest
string in the language where |<I>w</I>| ≥<!--greater than or equal-->
<I>m</I>. (Tip: if you get a large value for <I>m</I>, such as 18,
and you wish for a smaller one, press “Clear All” repeatedly
until one is generated.) If for some reason you enter a string that
is either not in the language or where |<I>w</I>| &lt; <I>m</I>, the
appropriate error message will appear in the <I>w</I> panel. When
finished, press enter, and the following two panels will become
visible.</P>
<P ALIGN=CENTER><IMG SRC="images/3&amp;4visible" NAME="Graphic3" ALIGN=MIDDLE WIDTH=641 HEIGHT=175 BORDER=0></P>
<P STYLE="margin-bottom: 0in">The computer has chosen a decomposition
based on the <I>w</I> value that you entered. Now, given this
decomposition, it is your duty to choose an <I>i</I> value. Go ahead
and enter 13 for <I>i</I>. However, instead of progressing to the
next panel, the following error message should appear.</P>
<P ALIGN=CENTER><IMG SRC="images/ierror" NAME="Graphic3" ALIGN=MIDDLE WIDTH=639 HEIGHT=59 BORDER=0></P>
<P STYLE="margin-bottom: 0in">For all languages JFLAP supports, you
can only enter either 0 or a value between 2 and 12 for i. A value of
1 will result in a pumped string equal to <I>w</I>, and thus is
always in the language, so it is excluded. <I>i</I> values larger
than 12 are excluded so the pumped string doesn't get too large.
Thus, go ahead and enter 2 for <I>i</I>, which is in the permissible
range. When finished, the screen should resemble the one below. This
example is also available in <A HREF="regCompFirst.jff">regCompFirst.jff</A>.</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/5visible" NAME="Graphic6" ALIGN=MIDDLE WIDTH=700 HEIGHT=700 BORDER=0></P>
<P STYLE="margin-bottom: 0in">You've won, because the computer could
not choose a valid decomposition. In fact, as seen through the proof
earlier, it never will find one with this language, so you will
always win. Go ahead and make a few more attempts to familiarize
yourself with the format, however. You can enter a new <I>w</I> value
if you want to keep the same <I>m</I> value, or just press enter in
the <I>w</I> text box if you want to keep both values. You can enter
a new <I>i</I> value if you want to retain <I>m</I>, <I>w</I>, and
the decomposition. Panel visibility will adjust itself accordingly.</P>
<P STYLE="margin-bottom: 0in; font-style: normal"><B>This concludes
our brief tutorial on regular pumping lemmas. Thanks for reading!</B></P>
</BODY>
</HTML>
